<template>
  <div class="page">
    <div class="ele-body">
      <a-card :bordered="false" :body-style="{ padding: '16px' }">
        <ele-pro-table
          ref="tableRef"
          row-key="id"
          :columns="columns"
          :datasource="datasource"
          tool-class="ele-toolbar-form"
          class="sys-org-table"
        >
          <template #bodyCell="{ column, record }">
            <template v-if="column.key === 'websiteName'">
              <a-space class="ele-cell">
                <a-avatar
                  :src="record.websiteLogo"
                  size="small"
                  shape="square"
                />
                <span class="ele-text-secondary">{{ record.websiteName }}</span>
              </a-space>
            </template>
            <template v-if="column.key === 'hostName'">
              <span class="ele-text-placeholder">{{ record.hostName }}</span>
            </template>
            <template v-if="column.key === 'hostType'">
              <span class="ele-text-placeholder">CNAME</span>
            </template>
            <template v-if="column.key === 'hostValue'">
              <span class="ele-text-placeholder">{{ record.hostValue }}</span>
            </template>
            <template v-if="column.key === 'photo'">
              <a-image :src="record.photo" />
            </template>
            <template v-if="column.key === 'status'">
              <a-switch
                v-model:checked="record.status"
                @change="updateStatus(record)"
              />
            </template>
            <template v-if="column.key === 'action'">
              <a-space>
                <a-button @click="openEdit(record)" size="small">管理</a-button>
                <a-popconfirm
                  title="确定要删除此域名吗？"
                  :disabled="record.home == 1"
                  @confirm="remove(record)"
                >
                  <a-button size="small">删除</a-button>
                </a-popconfirm>
              </a-space>
            </template>
          </template>
        </ele-pro-table>
      </a-card>

      <!-- 编辑弹窗 -->
      <Edit v-model:visible="showEdit" :data="current" @done="reload" />
    </div>
  </div>
</template>

<script lang="ts" setup>
  import { createVNode, ref } from 'vue';
  import { message, Modal } from 'ant-design-vue';
  import { ExclamationCircleOutlined } from '@ant-design/icons-vue';
  import type { EleProTable } from 'ele-admin-pro';
  import type {
    DatasourceFunction,
    ColumnItem
  } from 'ele-admin-pro/es/ele-pro-table/types';
  // import Search from './components/search.vue';
  import Edit from './components/edit.vue';
  import {
    pageWebsite,
    removeWebsite,
    removeBatchWebsite,
    updateWebsite
  } from '@/api/cms/website';
  import type { Website, WebsiteParam } from '@/api/cms/website/model';
  import { openPreview } from '@/utils/common';
  import type { Payment } from '@/api/system/payment/model';
  import { updatePayment } from '@/api/system/payment';

  // 表格实例
  const tableRef = ref<InstanceType<typeof EleProTable> | null>(null);

  // 表格选中数据
  const selection = ref<Website[]>([]);
  // 当前编辑数据
  const current = ref<Website | null>(null);
  // 是否显示编辑弹窗
  const showEdit = ref(false);
  // 是否显示批量移动弹窗
  const showMove = ref(false);

  // 表格数据源
  const datasource: DatasourceFunction = ({
    page,
    limit,
    where,
    orders,
    filters
  }) => {
    return pageWebsite({
      ...where,
      ...orders,
      page,
      limit
    });
  };

  // 表格列配置
  const columns = ref<ColumnItem[]>([
    {
      title: '网站名称',
      dataIndex: 'websiteName',
      width: 240,
      key: 'websiteName'
    },
    {
      title: '主机类型',
      dataIndex: 'websiteType',
      align: 'center',
      key: 'websiteType'
    },
    {
      title: '是否启用',
      dataIndex: 'status',
      width: 120,
      align: 'center',
      key: 'status'
    },
    {
      title: '操作',
      key: 'action',
      width: 120,
      align: 'center',
      hideInSetting: true
    }
  ]);

  /* 搜索 */
  const reload = (where?: WebsiteParam) => {
    selection.value = [];
    tableRef?.value?.reload({ where: where });
  };

  /* 打开编辑弹窗 */
  const openEdit = (row?: Website) => {
    current.value = row ?? null;
    showEdit.value = true;
  };

  /* 打开批量移动弹窗 */
  const openMove = () => {
    showMove.value = true;
  };

  const updateStatus = (item: Website) => {
    updateWebsite(item)
      .then((msg) => {
        message.success(msg);
      })
      .catch((msg) => {
        message.error(msg);
      });
  };

  /* 删除单个 */
  const remove = (row: Website) => {
    const hide = message.loading('请求中..', 0);
    removeWebsite(row.id)
      .then((msg) => {
        hide();
        message.success(msg);
        reload();
      })
      .catch((e) => {
        hide();
        message.error(e.message);
      });
  };

  /* 批量删除 */
  const removeBatch = () => {
    if (!selection.value.length) {
      message.error('请至少选择一条数据');
      return;
    }
    Modal.confirm({
      title: '提示',
      content: '确定要删除选中的记录吗?',
      icon: createVNode(ExclamationCircleOutlined),
      maskClosable: true,
      onOk: () => {
        const hide = message.loading('请求中..', 0);
        removeBatchWebsite(selection.value.map((d) => d.id))
          .then((msg) => {
            hide();
            message.success(msg);
            reload();
          })
          .catch((e) => {
            hide();
            message.error(e.message);
          });
      }
    });
  };
</script>
<script lang="ts">
  export default {
    name: 'Website'
  };
</script>
